#include "StdAfx.h"
#include "AudioGrabber.h"

//=====================================================================================//
//                                 class AudioGrabber                                  //
//=====================================================================================//
AudioGrabber::AudioGrabber(AudioGrabberObserver& observer)
: m_observer(observer)
{
}

AudioGrabber::~AudioGrabber()
{
}
//	receives a pointer to the sample buffer
STDMETHODIMP AudioGrabber::BufferCB(double SampleTime,BYTE *pBuffer,long BufferLen)
{
	return S_OK;
}
// receives a pointer to the media sample
STDMETHODIMP AudioGrabber::SampleCB(double SampleTime,IMediaSample *pSample)
{
	const unsigned int timestamp = static_cast<unsigned int>(SampleTime*1000);
	const long size = pSample->GetSize();
	unsigned char* buffer = 0;

	pSample->GetPointer(&buffer);
	m_observer.onAudioData(reinterpret_cast<const char*>(buffer),size,timestamp);

	return S_OK;
}
