#include "StdAfx.h"
#include "VideoGrabber.h"

//=====================================================================================//
//                                 class VideoGrabber                                  //
//=====================================================================================//
VideoGrabber::VideoGrabber(VideoGrabberObserver& observer)
: m_observer(observer)
{
}

VideoGrabber::~VideoGrabber()
{
}
///	receives a pointer to the sample buffer
STDMETHODIMP VideoGrabber::BufferCB(double SampleTime,BYTE *pBuffer,long BufferLen)
{
	return S_OK;
}
/// receives a pointer to the media sample
STDMETHODIMP VideoGrabber::SampleCB(double SampleTime,IMediaSample *pSample)
{
	const unsigned int timestamp = static_cast<unsigned int>(SampleTime*1000);
	const long size = pSample->GetSize();
	unsigned char* buffer = 0;

	pSample->GetPointer(&buffer);
	m_observer.onVideoData(reinterpret_cast<const char*>(buffer),size,timestamp);

	return S_OK;

}